con
  _clkmode = xtal1 + pll16x      'set to ext low speed crystal
  _xinfreq = 5_000_000          'Frequency on XIN pin is 5 MHz

  Ch1 = 0                       'pin number of the signal pin for channel one
  sc = 1

var
  long stack1[30]

obj
  debug : "PC_interface.spin"
  servo[1] : "servo_diagnostics.spin"

pub main | blob, temp
{{optional method used to test out the functions exposed in this object}}
'setup my pins
  'dira[Ch1+1]~~   'enable servo drive with my special circuit
  'outa[Ch1+1]~~   'enable servo drive with my special circuit
  dira[Ch1]~~                  'make the servo signal pin an output
  outa[Ch1]~                   'fix the servo pulse start state

  debug.start(31,30)            'start up my PC_interface
  debug.str(string("welcome to my GLORIOUS code. "))

  servo[0].Init                          'preload needed timing variables and start the shared serial driver
  {serial driver for the servo objects needs to be modified so that all the setup variables live in the DAT section of the code.
  the serial.start method should now also check out a lock for sharing the driver.  
  Also, Lock check methods need to be added (lock, locked?, unlock, or however fits with the hardware locks best)} 

  debug.str(string(".Int works "))
  
  cognew(servo[0].commander,@stack1)     'start a packet/servo dealy in a new cog

  debug.str(string("will the COGNEW return? "))
  'servo[n].commander                    'start the last packet/servo dealy in this cog


{'setup my objects
  
  debug.out($0D)                'return key
  debug.str(string("error code:"))
  debug.out($0D)                'return key }

  {repeat
    servo[0].move_servo(0,sc)
    temp := servo[0].get_error
    debug.dec(temp)
    debug.out($09)
    {temp := servo[1].get_error
    debug.dec(temp)
    debug.out($09)  }

    servo[0].move_servo(255,sc)
    temp := servo[0].get_error
    debug.dec(temp)
    debug.out($09)
    {temp := servo[1].get_error
    debug.dec(temp)
    debug.out($09) }

    servo[0].move_servo(245,sc)
    temp := servo[0].get_error
    debug.dec(temp)
    debug.out($09)
    {temp := servo[1].get_error
    debug.dec(temp)
    debug.out($0D) }
    debug.out($0D)   }



{'do some junk
  repeat
    Repeat 20
      servo.pulseout_us(Ch1,925)      'move to a position
      waitcnt(clkfreq/60 + cnt)   'waste 1/60th of a second
    blob := servo.find_pos_down(Ch1,1200)  'run the position search
    debug.dec(blob)               'print the search result
    debug.out($09)                'tab
    Repeat 20
      servo.pulseout_us(Ch1,1655)      'move to a position
      waitcnt(clkfreq/60 + cnt)   'waste 1/60th of a second
    blob := servo.find_pos_up(Ch1,1200)  'run the position search
    debug.dec(blob)               'print the search result
    debug.out($0D)                'new line   }

  {repeat
    {pulseout_us(Ch1, 1000)
    waitcnt(clkfreq/60 + cnt) 'wait 1/60 of a second }
    repeat blob from 925 to 1650 step 10
      pulseout_us(Ch1,blob)  'infinitely run my method
      waitcnt(clkfreq/60 + cnt) 'wait 1/60 of a second
    repeat blob from 1650 to 925 step 20
      pulseout_us(Ch1,blob)  'infinitely run my method
      waitcnt(clkfreq/60 + cnt) 'wait 1/60 of a second }